
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	addsection RELOCATEDDATA, nobits vstart=8000h
relocateddata:

	addsection HEADER, start=0

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
	iend


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "ELDCOMP"
	iend

start:
	push ss
	pop es
	extcallcall skipcomma
	dec si
	mov bx, commands
internaldatarelocation
	mov al, ';'
	mov di, word [bx]
.loop:
	inc di
	cmp al, ';'
	jne @FF
@@:
	lodsb
	extcallcall iseol?
	je @F
	stosb
	jmp @B

@@:
	mov al, 13
	stosb
	mov cx, di
	sub cx, word [bx]
	dec cx
	dec cx
	mov di, word [bx]
	mov byte [di], cl
	dec si
	lodsb
	inc bx
	inc bx
	mov di, word [bx]
	test di, di
	jnz .loop


	call clear_eld_space
	mov word [data_original], bx	; data
internaldatarelocation
	mov word [code_original], dx	; code
internaldatarelocation

	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3		; mark block as resident

	push word [relocateddata]
linkdatarelocation ext_inject_handler
	push word [relocateddata]
linkdatarelocation savesp
	push word [relocateddata]
linkdatarelocation throwsp
	mov word [eld_sp], sp
internaldatarelocation
	mov word [relocateddata], sp
linkdatarelocation savesp
	mov word [relocateddata], sp
linkdatarelocation throwsp

	mov word [relocateddata], .inject
linkdatarelocation ext_inject_handler, -4
internalcoderelocation
	extcallcall cmd3

.inject:
	mov bx, [step]
internaldatarelocation
	cmp bx, 4
	je .checksum
	cmp bx, 8 + 4
	jne @F
.checksum:
	mov si, word [data_original]
internaldatarelocation
	mov cx, word [relocateddata]
linkdatarelocation extdata_used
	add cx, word [relocateddata]
linkdatarelocation extdata
	sub cx, si
	mov word [word results + 0 + bx - 4], cx
internaldatarelocation
	xchg bx, dx
	call zz_hash
	xchg bx, dx
	mov word [word results + 2 + bx - 4], dx
internaldatarelocation

	mov si, word [code_original]
internaldatarelocation
	mov cx, word [relocateddata]
linkdatarelocation extseg_used
	sub cx, si
	mov word [word results + 4 + bx - 4], cx
internaldatarelocation
	call get_es_ext
	 push es
	 pop ds
	xchg bx, dx
	call zz_hash
	xchg bx, dx
	 push ss
	 pop es
	 push ss
	 pop ds
	mov word [word results + 6 + bx - 4], dx
internaldatarelocation

@@:
	cmp bx, 8
	jne @F

	push bx
	call clear_eld_space
	 push ss
	 pop es
	pop bx
@@:

	add word [step], strict byte 2
internaldatarelocation -3
	mov di, relocateddata + 1
linkdatarelocation line_in
	mov si, [word bx + commands]
internaldatarelocation
	test si, si
	jz .finish
	mov word [relocateddata], .inject
linkdatarelocation ext_inject_handler, -4
internalcoderelocation

.common:
	push di
	mov cx, words(256)
	rep movsw
	pop si
	inc si
	extcall skipwhite

	extcall cmd3_injected

.finish:
%if 0
	mov si, reclaimcommand
	mov word [relocateddata], .return
linkdatarelocation ext_inject_handler, -4
internalcoderelocation
	jmp .common
%elif 0
	mov word [relocateddata], .return
linkdatarelocation ext_inject_handler, -4
internalcoderelocation
	extcall cmd3
%endif

.return:
	mov sp, word [eld_sp]
internaldatarelocation
	pop word [relocateddata]
linkdatarelocation throwsp
	pop word [relocateddata]
linkdatarelocation savesp
	pop word [relocateddata]
linkdatarelocation ext_inject_handler
	call get_es_ext
	clropt [es:code + eldiFlags], eldifResident
internalcoderelocation -3		; mark block as free
	 push ss
	 pop es

	mov si, results
internaldatarelocation
	mov bx, 2
@@:
	mov cx, 4
	mov di, relocateddata
linkdatarelocation line_out
@@:
	lodsw
	extcallcall hexword
	mov al, 32
	stosb
	loop @B
	push bx
	extcallcall trimputs
	pop bx
	dec bx
	jnz @BB

	mov si, results
internaldatarelocation
	mov di, results + 8
internaldatarelocation
	cmpsw
	je @F
	mov dx, msg.mismatch.datalen
internaldatarelocation
	extcallcall putsz
@@:
	cmpsw
	je @F
	mov dx, msg.mismatch.datahash
internaldatarelocation
	extcallcall putsz
@@:
	cmpsw
	je @F
	mov dx, msg.mismatch.codelen
internaldatarelocation
	extcallcall putsz
@@:
	cmpsw
	je @F
	mov dx, msg.mismatch.codehash
internaldatarelocation
	extcallcall putsz
@@:


end:
	call get_es_ext
	mov ax, word [cs:code + eldiEndData]
internalcoderelocation			; ax -> our data end
	mov bx, 32			; prepare to keep 32 Bytes
	push ax
	sub ax, [relocateddata]		; ax = index into data behind our end
linkdatarelocation extdata
	cmp word [relocateddata], ax	; are we last ?
linkdatarelocation extdata_used
	pop ax
	jne @F				; no, keep >= 32 Bytes of instance -->
	xor bx, bx			; remember to free instance completely
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation			; get our length
	sub word [relocateddata], ax	; subtract from use counter
linkdatarelocation extdata_used
	xor ax, ax			; zero out our data references
					;  (in case we keep the instance)
	mov word [es:code + eldiStartData], ax
internalcoderelocation
	mov word [es:code + eldiEndData], ax
internalcoderelocation
@@:

	mov dx, word [cs:code + eldiStartCode]
internalcoderelocation
	add dx, bx			; -> behind to keep (= start if no data)
	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	cmp word [relocateddata], ax	; at end ?
linkdatarelocation extseg_used
	jne @F				; no, keep block as is -->
	mov word [cs:code + eldiEndCode], dx
internalcoderelocation			; modify end to -> behind to keep
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation			; = original length
	sub ax, bx			; = how much to free
	sub word [relocateddata], ax	; subtract from use counter
linkdatarelocation extseg_used
@@:

	extcallcall cmd3


get_es_ext:
	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcall ispm
	jz @F
	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	retn


clear_eld_space:
	 push ss
	 pop es
	mov di, word [relocateddata]
linkdatarelocation extdata_used
	mov cx, word [relocateddata]
linkdatarelocation extdata_size
	sub cx, di
	add di, word [relocateddata]
linkdatarelocation extdata
	mov bx, di
	mov al, 0
	rep stosb

	call get_es_ext
	mov di, word [relocateddata]
linkdatarelocation extseg_used
	mov cx, word [relocateddata]
linkdatarelocation extseg_size
	sub cx, di
	mov dx, di
	mov al, 0
	rep stosb
	retn


		; INP:	ds:si -> string to hash
		;	cx = length of string (may be zero)
		; OUT:	bx = hash value computed
		; CHG:	ax, si, cx
		; STT:	UP
zz_hash:
	mov bx, 1

		; INP:	ds:si -> string to hash
		;	cx = length of string (may be zero)
		;	bx = initial hash value
		; OUT:	bx = hash value computed
		; CHG:	ax, si, cx
		; STT:	UP
.bx_init:
	jcxz .end
.loop:
	xor ax, ax
	lodsb
	sub ax, bx
	push cx
	mov cl, 5
	shl bx, cl
	pop cx
	add bx, ax
	loop .loop
.end:
	retn


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%assign DATASECTION 1
%define DATAFIXUP - datastart + 0
datastart:

msg:
.mismatch.datalen:	asciz "Data length mismatch",13,10
.mismatch.datahash:	asciz "Data hash mismatch",13,10
.mismatch.codelen:	asciz "Code length mismatch",13,10
.mismatch.codehash:	asciz "Code hash mismatch",13,10


	align 2, db 0
results:
	times 8 dw 0

	align 2, db 0
commands:
	dw install_command_1
internaldatarelocation
	dw status_command_1
internaldatarelocation
	dw uninstall_command_1
internaldatarelocation
	dw reclaim_command_1
internaldatarelocation

	dw install_command_2
internaldatarelocation
	dw status_command_2
internaldatarelocation
	dw uninstall_command_2
internaldatarelocation
	dw reclaim_command_2
internaldatarelocation
	dw 0

step:	dw 0

%if 0
reclaimcommand:
	counted "ext reclaim.eld"
	db 13
%endif

uinit_data:

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data
	alignb 2
eld_sp:
	resw 1
code_original:
	resw 1
data_original:
	resw 1
install_command_1:
	resb 256
status_command_1:
	resb 256
uninstall_command_1:
	resb 256
reclaim_command_1:
	resb 256
install_command_2:
	resb 256
status_command_2:
	resb 256
uninstall_command_2:
	resb 256
reclaim_command_2:
	resb 256

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
